import json
import random

portal = context.getPortalObject()

client_role = 'ors/client'

password_length = 16
system_random = random.SystemRandom()
alphabet = string.ascii_letters + string.digits
client_init_password = ''.join(system_random.choice(alphabet) for i in range(password_length))

project = context.portal_catalog.getResultValue(
  portal_type='Project',
  title=project_title,
  reference=project_reference,
  validation_state='validated'
)
if project:
  error_msg = "Client project %s already registered." % project_reference
  response_dict = dict(error_msg=error_msg)
  return json.dumps(response_dict)

user = context.portal_catalog.getResultValue(
  portal_type='Person',
  reference=client_username,
  validation_state='validated'
)
if user:
  error_msg = "Client account username not available: %s." % client_username
  response_dict = dict(error_msg=error_msg)
  return json.dumps(response_dict)

ors_reference = 'ors.' + ors_tag
# Search for DAU across all client projects to prevent tag collision
data_acquisition_unit = context.portal_catalog.getResultValue(
  portal_type='Data Acquisition Unit',
  reference=ors_reference,
  # Do not test for title collision: irrelevant
  validation_state='validated'
)
if data_acquisition_unit:
  error_msg = "ORS with tag %s already registered." % ors_tag
  response_dict = dict(error_msg=error_msg)
  return json.dumps(response_dict)

project = portal.project_module.newContent(
  portal_type='Project',
  title=project_title,
  reference=project_reference
)
project.validate()
project_url = project.getRelativeUrl()

user = portal.person_module.newContent(portal_type='Person', reference=client_username)
user.newContent(portal_type='Assignment', destination_project=project_url, role=client_role).open()
user.newContent(portal_type='ERP5 Login', reference=client_username, password=client_init_password).validate()
user.validate()

data_acquisition_unit = portal.data_acquisition_unit_module.newContent(
  portal_type='Data Acquisition Unit',
  reference=ors_reference,
  title=ors_title,
  destination_project=project_url,
)
data_acquisition_unit.validate()
data_supply = data_acquisition_unit.DataAcquisitionUnit_createORSDataSupply(batch=1)

data_acquisition_unit.updateLocalRolesOnSecurityGroups()
data_supply.updateLocalRolesOnSecurityGroups()

response_dict = dict(username=client_username, init_password=client_init_password)
return json.dumps(response_dict)
